﻿/*
 *         Progetto: Uso del costrutto fork/join (libreria TPL)
 * 
 *           Autore: Roberto Fuligni
 *  Ultima modifica: 16/11/2018
 *  
 */

using System;
using System.Threading.Tasks;

namespace ParalleloTPL
{
    class ParalleloTPL
    {
        static int A, B, C, D, E, F, G, H;
        static void Main(string[] args)
        {
            Task tsk1 = Task.Factory.StartNew(Proc1);   // Metodo classico di avvio di un nuovo task

            // In alternativa è possibile indicare direttamente le attività svolte 
            // dal task utilizzando una "istruzione lambda" (statement lambda): il
            // codice risulta in questo caso più compatto.
            Task tsk2 = Task.Factory.StartNew( () => {
               C = 30;
               F = C * C;
               Console.WriteLine("F: {0}", F);
            });

            A = 10;
            D = A + 5;
            Console.WriteLine("D: {0}", D);

            tsk1.Wait();  // Attende il completamento del task tsk1

            G = E - D;
            Console.WriteLine("G: {0}", G);

            tsk2.Wait();   // Attende il completamento del task tsk2

            H = F + G;
            Console.WriteLine("H: {0}", H);


        }
        static void Proc1()
        {
            B = 20;
            E = B * 2;
            Console.WriteLine("E: {0}", E);
        }
    }
}
